class ServPackager expands Actor config (ServerPackager);

var bool bPreInit;
var int i;
var() config string GmType[32];
var() config string	SrvPacks0[32], SrvPacks1[32], SrvPacks2[32], SrvPacks3[32], SrvPacks4[32], SrvPacks5[32], SrvPacks6[32], SrvPacks7[32],
					SrvPacks8[32], SrvPacks9[32], SrvPacks10[32], SrvPacks11[32], SrvPacks12[32], SrvPacks13[32], SrvPacks14[32], SrvPacks15[32],
					SrvPacks16[32], SrvPacks17[32], SrvPacks18[32], SrvPacks19[32], SrvPacks20[32], SrvPacks21[32], SrvPacks22[32], SrvPacks23[32],
					SrvPacks24[32], SrvPacks25[32], SrvPacks26[32], SrvPacks27[32], SrvPacks28[32], SrvPacks29[32], SrvPacks30[32], SrvPacks31[32];

native(1718) final function bool AddToPackageMap( optional string PkgName);
native(1719) final function bool IsInPackageMap( optional string PkgName, optional bool bServerPackagesOnly);

event PreBeginPlay()
{
	if ( !bPreInit )
	{
		bPreInit = True;
		ScanAndSetGame();
	}
}

final function ScanAndSetGame()
{
	if ( GmType[0] == "" )
		SaveConfig();
	if (Caps(string(Outer.Name)) ~= "UT-LOGO-MAP")
		log ("Packages are skipped for this map...",'ServPackager');
	else
	{
		i = 0;
		for (i = 0; i < 32; i++)
		{
			if ( string(Level.Game.Class.Name) ~= GmType[i] )
			{
				log ("Found game-type"@GmType[i],'ServPackager');
				SetupPacks(i);
				break;
			}
		}
	}
}

final function SetupPacks(int i)
{
	local int k;

	k = 0;
	for ( k = 0; k < 32; k++ )
	{
		if ( i == 0 )
		{
			if ( (SrvPacks0[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks0[k]))
				{
					log ("Adding"@SrvPacks0[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks0[k]);
				}
				else
				{
					log ("Package"@SrvPacks0[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 1 )
		{
			if ( (SrvPacks1[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks1[k]))
				{
					log ("Adding"@SrvPacks1[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks1[k]);
				}
				else
				{
					log ("Package"@SrvPacks1[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 2 )
		{
			if ( (SrvPacks2[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks2[k]))
				{
					log ("Adding"@SrvPacks2[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks2[k]);
				}
				else
				{
					log ("Package"@SrvPacks2[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 3 )
		{
			if ( (SrvPacks3[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks3[k]))
				{
					log ("Adding"@SrvPacks3[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks3[k]);
				}
				else
				{
					log ("Package"@SrvPacks3[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 4 )
		{
			if ( (SrvPacks4[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks4[k]))
				{
					log ("Adding"@SrvPacks4[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks4[k]);
				}
				else
				{
					log ("Package"@SrvPacks4[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 5 )
		{
			if ( (SrvPacks5[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks5[k]))
				{
					log ("Adding"@SrvPacks5[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks5[k]);
				}
				else
				{
					log ("Package"@SrvPacks5[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 6 )
		{
			if ( (SrvPacks6[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks6[k]))
				{
					log ("Adding"@SrvPacks6[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks6[k]);
				}
				else
				{
					log ("Package"@SrvPacks6[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 7 )
		{
			if ( (SrvPacks7[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks7[k]))
				{
					log ("Adding"@SrvPacks7[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks7[k]);
				}
				else
				{
					log ("Package"@SrvPacks7[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 8 )
		{
			if ( (SrvPacks8[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks8[k]))
				{
					log ("Adding"@SrvPacks8[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks8[k]);
				}
				else
				{
					log ("Package"@SrvPacks8[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 9 )
		{
			if ( (SrvPacks9[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks9[k]))
				{
					log ("Adding"@SrvPacks9[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks9[k]);
				}
				else
				{
					log ("Package"@SrvPacks9[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 10 )
		{
			if ( (SrvPacks10[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks10[k]))
				{
					log ("Adding"@SrvPacks10[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks10[k]);
				}
				else
				{
					log ("Package"@SrvPacks10[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 11 )
		{
			if ( (SrvPacks11[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks11[k]))
				{
					log ("Adding"@SrvPacks11[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks11[k]);
				}
				else
				{
					log ("Package"@SrvPacks11[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 12 )
		{
			if ( (SrvPacks12[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks12[k]))
				{
					log ("Adding"@SrvPacks12[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks12[k]);
				}
				else
				{
					log ("Package"@SrvPacks12[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 13 )
		{
			if ( (SrvPacks13[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks13[k]))
				{
					log ("Adding"@SrvPacks13[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks13[k]);
				}
				else
				{
					log ("Package"@SrvPacks13[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 14 )
		{
			if ( (SrvPacks14[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks14[k]))
				{
					log ("Adding"@SrvPacks14[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks14[k]);
				}
				else
				{
					log ("Package"@SrvPacks14[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 15 )
		{
			if ( (SrvPacks15[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks15[k]))
				{
					log ("Adding"@SrvPacks15[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks15[k]);
				}
				else
				{
					log ("Package"@SrvPacks15[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 16 )
		{
			if ( (SrvPacks16[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks16[k]))
				{
					log ("Adding"@SrvPacks16[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks16[k]);
				}
				else
				{
					log ("Package"@SrvPacks16[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 17 )
		{
			if ( (SrvPacks17[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks17[k]))
				{
					log ("Adding"@SrvPacks17[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks17[k]);
				}
				else
				{
					log ("Package"@SrvPacks17[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 18 )
		{
			if ( (SrvPacks18[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks18[k]))
				{
					log ("Adding"@SrvPacks18[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks18[k]);
				}
				else
				{
					log ("Package"@SrvPacks18[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 19 )
		{
			if ( (SrvPacks19[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks19[k]))
				{
					log ("Adding"@SrvPacks19[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks19[k]);
				}
				else
				{
					log ("Package"@SrvPacks19[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 20 )
		{
			if ( (SrvPacks20[k]) != "")
			{
				if (!IsInPackageMap(SrvPacks20[k]))
				{
					log ("Adding"@SrvPacks20[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks20[k]);
				}
				else
				{
					log ("Package"@SrvPacks20[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 21 )
		{
			if ( (SrvPacks21[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks21[k]))
				{
					log ("Adding"@SrvPacks21[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks21[k]);
				}
				else
				{
					log ("Package"@SrvPacks21[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 22 )
		{
			if ( (SrvPacks22[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks22[k]))
				{
					log ("Adding"@SrvPacks22[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks22[k]);
				}
				else
				{
					log ("Package"@SrvPacks22[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 23 )
		{
			if ( (SrvPacks23[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks23[k]))
				{
					log ("Adding"@SrvPacks23[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks23[k]);
				}
				else
				{
					log ("Package"@SrvPacks23[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 24 )
		{
			if ( (SrvPacks24[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks24[k]))
				{
					log ("Adding"@SrvPacks24[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks24[k]);
				}
				else
				{
					log ("Package"@SrvPacks24[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 25 )
		{
			if ( (SrvPacks25[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks25[k]))
				{
					log ("Adding"@SrvPacks25[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks25[k]);
				}
				else
				{
					log ("Package"@SrvPacks25[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 26 )
		{
			if ( (SrvPacks26[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks26[k]))
				{
					log ("Adding"@SrvPacks26[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks26[k]);
				}
				else
				{
					log ("Package"@SrvPacks26[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 27 )
		{
			if ( (SrvPacks27[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks27[k]))
				{
					log ("Adding"@SrvPacks27[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks27[k]);
				}
				else
				{
					log ("Package"@SrvPacks27[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 28 )
		{
			if ( (SrvPacks28[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks28[k]))
				{
					log ("Adding"@SrvPacks28[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks28[k]);
				}
				else
				{
					log ("Package"@SrvPacks28[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 29 )
		{
			if ( (SrvPacks29[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks29[k]))
				{
					log ("Adding"@SrvPacks29[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks29[k]);
				}
				else
				{
					log ("Package"@SrvPacks29[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 30 )
		{
			if ( (SrvPacks30[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks30[k]))
				{
					log ("Adding"@SrvPacks30[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks30[k]);
				}
				else
				{
					log ("Package"@SrvPacks30[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
			continue;
		}
		if ( i == 31 )
		{
			if ( (SrvPacks31[k]) != "" )
			{
				if (!IsInPackageMap(SrvPacks31[k]))
				{
					log ("Adding"@SrvPacks31[k]@"in ServerPackages.",'ServPackager');
					AddToPackageMap(SrvPacks31[k]);
				}
				else
				{
					log ("Package"@SrvPacks31[k]@"is already declared in ServerPackages. It won't be reloaded...",'ServPackager');
				}
			}
		}
	}
}